import {
  __name,
  __objRest
} from "./chunk-B36FS7SS.js";

// components/form/inputs/Checkboxgroup.tsx
import React, { useState } from "react";
import { FormCheck } from "react-bootstrap";
import without from "lodash/without.js";
import uniq from "lodash/uniq.js";
import isEmpty from "lodash/isEmpty.js";
import { useFormContext, useVulcanComponents } from "@vulcanjs/react-ui";
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
__name(_extends, "_extends");
var otherMarker = "[other]";
var isOtherValue = /* @__PURE__ */ __name((s) => s && typeof s === "string" && s.substr(0, otherMarker.length) === otherMarker, "isOtherValue");
var removeOtherMarker = /* @__PURE__ */ __name((s) => s && typeof s === "string" && s.substr(otherMarker.length), "removeOtherMarker");
var addOtherMarker = /* @__PURE__ */ __name((s) => `${otherMarker}${s}`, "addOtherMarker");
var removeOtherValue = /* @__PURE__ */ __name((a) => {
  return a.filter((s) => !isOtherValue(s));
}, "removeOtherValue");
var OtherComponent = /* @__PURE__ */ __name(({ value, path }) => {
  const { updateCurrentValues } = useFormContext();
  const Components = useVulcanComponents();
  const otherValue = removeOtherMarker(value.find(isOtherValue));
  const withoutOtherValue = removeOtherValue(value);
  const [showOther, setShowOther] = useState(!!otherValue);
  const [textFieldValue, setTextFieldValue] = useState(otherValue);
  const textFieldInputProperties = {
    name,
    value: textFieldValue,
    onChange: (event) => {
      const fieldValue = event.target.value;
      setTextFieldValue(fieldValue);
      const newValue = isEmpty(fieldValue) ? withoutOtherValue : [
        ...withoutOtherValue,
        addOtherMarker(fieldValue)
      ];
      updateCurrentValues({
        [path]: newValue
      });
    }
  };
  const textFieldItemProperties = {
    layout: "elementOnly"
  };
  return /* @__PURE__ */ React.createElement("div", {
    className: "form-option-other"
  }, /* @__PURE__ */ React.createElement(FormCheck, {
    layout: "elementOnly",
    label: "Other",
    value: showOther,
    checked: showOther,
    onClick: (event) => {
      const isChecked = event.target.checked;
      setShowOther(isChecked);
      if (isChecked) {
        if (textFieldValue) {
          updateCurrentValues({
            [path]: [
              ...withoutOtherValue,
              addOtherMarker(textFieldValue)
            ]
          });
        }
      } else {
        updateCurrentValues({
          [path]: withoutOtherValue
        });
      }
    }
  }), showOther && /* @__PURE__ */ React.createElement(Components.FormComponentText, {
    inputProperties: textFieldInputProperties,
    itemProperties: textFieldItemProperties
  }));
}, "OtherComponent");
var FormComponentCheckboxGroup = /* @__PURE__ */ __name(({ refFunction, label, path, value, formType, disabled, inputProperties, itemProperties = {} }) => {
  const { updateCurrentValues } = useFormContext();
  const Components = useVulcanComponents();
  const _a = inputProperties, { options = [], name: name2 } = _a, otherInputProperties = __objRest(_a, ["options", "name"]);
  value = value ? uniq(value.filter((v) => isOtherValue(v) || options.map((o) => o.value).includes(v))) : [];
  const hasValue = value.length > 0;
  if (formType === "new" && value.length === 0) {
    const checkedValues = options.filter((o) => o.checked === true).map((option) => option.value);
    if (checkedValues.length) {
      value = checkedValues;
    }
  }
  return /* @__PURE__ */ React.createElement(Components.FormItem, _extends({
    path,
    label
  }, itemProperties), /* @__PURE__ */ React.createElement("div", {
    className: "form-item-options"
  }, options.map((option, i) => {
    const isChecked1 = value.includes(option.value);
    const checkClass = hasValue ? isChecked1 ? "form-check-checked" : "form-check-unchecked" : "";
    return /* @__PURE__ */ React.createElement(FormCheck, _extends({}, otherInputProperties, {
      name: name2,
      layout: "elementOnly",
      key: i,
      label: /* @__PURE__ */ React.createElement(Components.FormOptionLabel, {
        option,
        name: name2
      }),
      value: isChecked1,
      checked: isChecked1,
      id: `${path}.${i}`,
      path: `${path}.${i}`,
      ref: refFunction,
      onChange: (event) => {
        const isChecked = event.target.checked;
        const newValue = isChecked ? [
          ...value,
          option.value
        ] : without(value, option.value);
        updateCurrentValues({
          [path]: newValue
        });
      },
      className: checkClass
    }));
  }), itemProperties.showOther && /* @__PURE__ */ React.createElement(OtherComponent, {
    value,
    path
  })));
}, "FormComponentCheckboxGroup");

export {
  otherMarker,
  isOtherValue,
  removeOtherMarker,
  addOtherMarker,
  removeOtherValue,
  FormComponentCheckboxGroup
};
//# sourceMappingURL=chunk-BRZX66ZS.js.map