import {
  lib_default
} from "./chunk-OGXJKHRC.js";
import {
  __name
} from "./chunk-B36FS7SS.js";

// components/form/inputs/Autocomplete.tsx
import { AsyncTypeahead } from "react-bootstrap-typeahead";
import React, { useState } from "react";
import { useLazyQuery } from "@apollo/client";
import { useVulcanComponents } from "@vulcanjs/react-ui";
import { useFormContext } from "@vulcanjs/react-ui";
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
__name(_extends, "_extends");
var Autocomplete = /* @__PURE__ */ __name((props) => {
  const {
    queryData,
    refFunction,
    path,
    inputProperties = {},
    itemProperties = {},
    autocompleteQuery,
    optionsFunction,
    name
  } = props;
  const Components = useVulcanComponents();
  const { updateCurrentValues } = useFormContext();
  const { value, label } = inputProperties;
  const [queryString1 = "xohaskjdhaskdjalh", setQueryString] = useState();
  const [loadAutocompleteOptions, { loading, error, data }] = useLazyQuery(lib_default(autocompleteQuery()), {
    variables: {
      queryString: queryString1
    }
  });
  if (error) {
    throw new Error(error.message);
  }
  const autocompleteOptions = data && optionsFunction({
    data
  });
  const selectedItem = queryData ? optionsFunction({
    data: queryData
  }).filter((d) => value === d.value) : [];
  return /* @__PURE__ */ React.createElement(Components.FormItem, _extends({
    path,
    name,
    label
  }, itemProperties), /* @__PURE__ */ React.createElement(AsyncTypeahead, _extends({}, inputProperties, {
    multiple: false,
    onChange: (selected) => {
      if (selected.length === 0) {
        updateCurrentValues({
          [path]: null
        });
      } else {
        const selectedId = selected[0].value;
        updateCurrentValues({
          [path]: selectedId
        });
      }
    },
    options: autocompleteOptions,
    id: path,
    ref: refFunction,
    onSearch: (queryString) => {
      setQueryString(queryString);
      loadAutocompleteOptions();
    },
    isLoading: loading,
    selected: selectedItem
  })));
}, "Autocomplete");

export {
  Autocomplete
};
//# sourceMappingURL=chunk-F5WXVNI4.js.map