import {
  lib_default
} from "./chunk-OGXJKHRC.js";
import {
  __name
} from "./chunk-B36FS7SS.js";

// components/form/inputs/AutocompleteMultiple.tsx
import { AsyncTypeahead } from "react-bootstrap-typeahead";
import React, { useState } from "react";
import { useLazyQuery } from "@apollo/client";
import { useVulcanComponents } from "@vulcanjs/react-ui";
import { useFormContext } from "@vulcanjs/react-ui";
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
__name(_extends, "_extends");
var AutocompleteMultiple = /* @__PURE__ */ __name((props) => {
  const {
    queryData,
    refFunction,
    path,
    inputProperties = {},
    itemProperties = {},
    autocompleteQuery,
    optionsFunction
  } = props;
  const { updateCurrentValues } = useFormContext();
  const Components = useVulcanComponents();
  const { value: value1, label } = inputProperties;
  const [queryString1, setQueryString] = useState();
  const [loadAutocompleteOptions, { loading, error, data }] = useLazyQuery(lib_default(autocompleteQuery()), {
    variables: {
      queryString: queryString1
    }
  });
  const autocompleteOptions = data && optionsFunction({
    data
  });
  const selectedItems = queryData && optionsFunction({
    data: queryData
  }).filter((d) => value1.includes(d.value));
  return /* @__PURE__ */ React.createElement(Components.FormItem, _extends({}, props, itemProperties, {
    name: path
  }), error && error.message && /* @__PURE__ */ React.createElement(Components.Alert, {
    className: "flash-message",
    variant: "danger"
  }, error.message), /* @__PURE__ */ React.createElement(AsyncTypeahead, _extends({}, inputProperties, {
    multiple: true,
    onChange: (selected) => {
      const selectedIds = selected.map(({ value }) => value);
      updateCurrentValues({
        [path]: selectedIds
      });
    },
    options: autocompleteOptions,
    id: path,
    inputProps: {
      id: path
    },
    ref: refFunction,
    onSearch: (queryString) => {
      setQueryString(queryString);
      loadAutocompleteOptions();
    },
    isLoading: loading,
    selected: selectedItems
  })));
}, "AutocompleteMultiple");

export {
  AutocompleteMultiple
};
//# sourceMappingURL=chunk-WMOCPSIO.js.map