import {
  __name,
  __objRest
} from "../../../chunk-B36FS7SS.js";

// components/form/inputs/Likert.tsx
import { useFormContext, useVulcanComponents } from "@vulcanjs/react-ui";
import React from "react";
import { FormCheck } from "react-bootstrap";
function _extends() {
  _extends = Object.assign || function(target) {
    for (var i = 1; i < arguments.length; i++) {
      var source = arguments[i];
      for (var key in source) {
        if (Object.prototype.hasOwnProperty.call(source, key)) {
          target[key] = source[key];
        }
      }
    }
    return target;
  };
  return _extends.apply(this, arguments);
}
__name(_extends, "_extends");
var getRange = /* @__PURE__ */ __name((n = 10) => [
  ...Array(n).keys()
].map((i) => i + 1).map((i) => ({
  value: i,
  label: i
})), "getRange");
var Likert = /* @__PURE__ */ __name(({ refFunction, path, label, inputProperties, itemProperties = {} }) => {
  const { updateCurrentValues } = useFormContext();
  const Components = useVulcanComponents();
  const _a = inputProperties, {
    options = [],
    value
  } = _a, otherInputProperties = __objRest(_a, [
    "options",
    "value"
  ]);
  const hasValue = value !== "";
  return /* @__PURE__ */ React.createElement(Components.FormItem, _extends({
    path,
    label
  }, itemProperties), /* @__PURE__ */ React.createElement("div", {
    className: "likert-scale"
  }, /* @__PURE__ */ React.createElement("div", {
    className: "likert-row"
  }, /* @__PURE__ */ React.createElement("div", null), getRange().map((rating, i) => /* @__PURE__ */ React.createElement("div", {
    key: i,
    className: "likert-row-cell"
  }, i + 1))), options.map((option, i1) => {
    const optionPath = `${path}.${option.value}`;
    const optionValue = value && value[option.value];
    return /* @__PURE__ */ React.createElement("div", {
      key: i1,
      className: "likert-row"
    }, /* @__PURE__ */ React.createElement("div", {
      className: "likert-row-heading"
    }, option.label), getRange().map((rating, i) => {
      const isChecked = optionValue === rating.value;
      const checkClass = hasValue ? isChecked ? "form-check-checked" : "form-check-unchecked" : "";
      return /* @__PURE__ */ React.createElement("div", {
        key: i,
        className: "likert-row-cell"
      }, /* @__PURE__ */ React.createElement(FormCheck, _extends({}, otherInputProperties, {
        key: i,
        layout: "elementOnly",
        type: "radio",
        label: rating.label,
        value: rating.value,
        name: optionPath,
        id: optionPath,
        path: optionPath,
        ref: refFunction,
        checked: isChecked,
        className: checkClass,
        onChange: () => {
          updateCurrentValues({
            [optionPath]: rating.value
          });
        }
      })));
    }));
  })));
}, "Likert");
export {
  Likert
};
//# sourceMappingURL=Likert.js.map